<?php
namespace BackOfficeOptimizer\Providers;

use Zeedhi\Framework\DataSource\DataSet;

class LoginProvider{
    protected $connection;

    public function __construct($connection){
        $this->connection = $connection;
    }

    /**
     * Temporary function location.
     * Should be moved to a login provider|reposity
     * 
     * @param DTO\Row $userData - Object containing 
     * user data inputed in login.
     * 
     * @return DataSet
     */
    public function doLogin($userData){
        $sql = "SELECT O.DSEMAILOPER, O.NMOPERADOR, O.CDOPERADOR, O.CDFILIALSELECIONADA, O.NRORG, O.DSIMAGEMOPER, F.NMFILIAL FROM OPERADOR O INNER JOIN FILIAL F ON F.CDFILIAL (+) = O.CDFILIALSELECIONADA WHERE DSEMAILOPER =:DSEMAILOPER AND CDSENHAOPERWEB =:CDSENHAOPERWEB AND O.IDOPERATIVO = 'A' AND NVL(:NRORG,O.NRORG) = O.NRORG AND NVL(:CDOPERADOR,O.CDOPERADOR) = O.CDOPERADOR";
        
        $params = array(
            "DSEMAILOPER"=>$userData->get('username'),
            "CDSENHAOPERWEB"=>$userData->get('password'),
            "NRORG"=>$userData->has('nrorg') ? $userData->get('nrorg') : null,
            "CDOPERADOR"=>$userData->has('usercode') ? $userData->get('usercode') : null
        );

        $statement = $this->connection->prepare($sql);
        $statement->execute($params);
        return $statement->fetchAll();
    }
}
